function [model] = convert_from_qmr(model, G, inhibit, leak, prior)

if (strcmp (model.type, 'pairwise-discrete' ) )

    error ('convert_from_qmr(...) can not be used with a Pairwise Graph.');

end



if (strcmp (model.type, 'factorgraph-discrete' ) )

    [m n] = size(G);

    model.number_vertices = m;
    model.number_potential_tables = n;
    
    a {1} = 0;
    
    %clear model.internal_potentials ;
    
    model.internal_potentials =a;
    model.link_tables = a;
    
    for a=1:m
    
    model.internal_potentials {a} = [1-prior prior];
    
    end
    
    c= 1;

    for j = 1:n

        a = 1;
        link = [];
        inhi = [leak(j)];
        
        for i = 1:m

            if ( G(i,j) == 1)

                link (a) = i;
                inhi (a +1) = inhibit(i,j);
                a = a+1;

            end

        end

        model.link_tables(c) = { link };
        model.potential_tables(c) = { inhi };
        model.number_potential_tables = c;
        c = c+1;

    end

model.structure_code = 'qmr';
model.internal_potentials_bool = true;

model = set_all_variables_sizes(model, 2);

end