#include <functional>
#include <vector>

#include <boost/graph/graph_traits.hpp>

template <class Graph, class ColorMap, class ParentMap>
bool get_tree(Graph &, ColorMap, ParentMap);

template <class Graph, class ColorMap>
unsigned int check_phantom_potential_status(typename boost::graph_traits<Graph>::vertex_descriptor, ColorMap &, Graph &);

template <class Graph, class ColorMap, class ParentMap>
void partition_graph_into_trees_implementation (Graph &, ColorMap, ParentMap );

template <class Graph>
void partition_graph_into_trees (Graph &);

template <class Graph>
void partition_mrf_graph_into_chains (Graph &);

template <class Graph>
void partition_simple_chain(Graph &);

template <class Graph, class ColorMap, class ParentMap>
void prune_out_degree_1 (Graph &, ColorMap ParentMap);

template <class Graph, class ColorMap, class ParentMap>
void prune_out_degree_2 (Graph &, ColorMap, ParentMap);

template <class Graph, class VertexDescriptor = typename boost::graph_traits<Graph>::vertex_descriptor>
class GraphPartitionQueueOrder : public std::binary_function< boost::tuple <VertexDescriptor, unsigned int, unsigned int, unsigned int, unsigned int>, boost::tuple <VertexDescriptor, unsigned int, unsigned int, unsigned int, unsigned int>, bool>
{
	
private:
	
	const Graph & g;
	
public:
	
	typedef boost::tuple <VertexDescriptor, unsigned int, unsigned int, unsigned int, unsigned int> myTuple;
	
	bool operator()(myTuple, myTuple) const;
	
	GraphPartitionQueueOrder(const Graph &);
};
