#ifndef INPUTFUNCTIONS_H
#define INPUTFUNCTIONS_H

#include <string>
#include <boost/graph/adjacency_list.hpp>

//template <class Graph>
//bool read_graph_from_file(std::string, Graph * &);

//template <class Graph>
//Graph * make_random_graph (const unsigned int, const double);

template <class Graph>
Graph * make_mrf_graph (const unsigned int, const unsigned int);

template <class Graph>
Graph * make_simple_chain_graph (const unsigned int);

template <class Graph>
void randomize_discrete_pairwise_graph (Graph &);

template <class Graph>
void randomize_discrete_pairwise_symmetric_graph (Graph &);

template <class Graph>
void fill_discrete_pairwise_symmetric_graph (Graph &);

template <class Graph>
void randomize_non_parametric_pairwise_graph (Graph &);

template < class Graph>
void export_computed_means(std::string, Graph &);

template < class Graph>
void read_reference_means (std::string, Graph &);

template <class Graph>
void initialize_random_variables (Graph &);

template <class Graph>
void set_observations (Graph &);

template <class Graph>
void set_special_mrf_observations (Graph &);

//************* Generic and Specialization Declarations ******************** //

template <class Graph, class PropertyMapType>
class set_vertex_index_map
{

private:
	
public:
	
	set_vertex_index_map (Graph & );
	
	void operator() ();	
};

template <class Graph>
class set_vertex_index_map <Graph,  boost::lvalue_property_map_tag>
{
	
private:
	
	Graph & g;
	
public:
	
	set_vertex_index_map (Graph & a);
	
	void operator() ();
	
};

//************* End of Generic and Specialization Declarations ******************** //

// New functions

template <class Graph>
void create_pairwise_square_lattice (const unsigned int, const unsigned int, Graph &);

template <class Graph>
void create_random_graph (const double, Graph &);

#endif
